var ngp = require('../../ecxngp');
function setSessionandHeader(res,req)
{
    return new Promise(function(resolve,reject)
    {
        try
        {
            var ngState = ngp.getSessionState(req, res);
            var ecxSid = ngState.ecxSid;
            var host = ngp.ecxSidHash[ecxSid].host;
            var client = host;
            var guiReqProtocol = ngp.ecxSidHash[ecxSid].reqProtocol;                                                    
            if ( guiReqProtocol == 'https' )
                    host = "https://"+host;
            else
            {
                host = "http://"+host+":"+ngp.ecxInternal;
            }
            resolve([ecxSid , host, client]);
        }
        catch(error)
        {
            console.error(error)
            const err = new Error("Can't parse host and sessionid correctly")
            err.status = 403
            reject(err);
        }
    })
}

function replaceLocalhost(url) 
{
  return replaceHostname(url, 'localhost');
}

function replaceHostname(url, hostname) 
{
  let retval = new URL(url);
  retval.hostname = hostname;
  return retval.href;
}

function processXforwardedHeaders(req, option) {
    if (req.headers['x-forwarded-host']) { option.headers['x-forwarded-host'] = req.headers['x-forwarded-host']; }
    if (req.headers['x-forwarded-proto']) { option.headers['x-forwarded-proto'] = req.headers['x-forwarded-proto']; }
    if (req.headers['x-forwarded-port']) { option.headers['x-forwarded-port'] = req.headers['x-forwarded-port']; }
    if (req.headers['x-forwarded-for']) { option.headers['x-forwarded-for'] = req.headers['x-forwarded-for']; }
}

function applyXforwardedHeadersToUrl(option, url) {
  let retVal = new URL(url);
  if (option.headers['x-forwarded-host']) { retVal.hostname = option.headers['x-forwarded-host'] }
  if (option.headers['x-forwarded-proto']) { retVal.protocol = option.headers['x-forwarded-proto'] }
  if (option.headers['x-forwarded-port']) { retVal.port = option.headers['x-forwarded-port'] }
  return retVal.href;
}


module.exports = {
    setSessionandHeader : setSessionandHeader,
    replaceLocalhost : replaceLocalhost,
    replaceHostname : replaceHostname,
    processXforwardedHeaders : processXforwardedHeaders,
    applyXforwardedHeadersToUrl : applyXforwardedHeadersToUrl 
}
