if (!('contains' in String.prototype)) {
  String.prototype.contains = function(str, startIndex) {
    return ''.indexOf.call(this, str, startIndex) !== -1;
  };
}

if (typeof String.prototype.startsWith != 'function') {
  String.prototype.startsWith = function(prefix) {
      return this.slice(0, prefix.length) == prefix;
  };
}
   
if (typeof String.prototype.endsWith != 'function') {
  String.prototype.endsWith = function(suffix) {
      return this.slice(-suffix.length) == suffix;
  };
}


var ngp = require('./ecxngp');   


var funcSteps = [                                                                                    // absolutely no calls to SPP; these strux and handshake protocol merely pro forma
{                                                                                                
  continue: 'next',                                                                            
  name: 'pingURL',
  verb: null,
  path: null,
  ip: null,                                                                                                                                        
  port: null, 
  type: null,
  cb: function(res, data){ ngp.logMsg('info', 'Step=' + this.name + ' finished');}
}, 	
];


const pingURLFuncs = {
  pingURL: function(step, funcStream, ecxSessionId, oFromNg, cb){          
    pingURL(step, funcStream, ecxSessionId, oFromNg, cb);      	                     
  },	
};


exports.init = init;


function init(req, res, providerType)                                    
{
    var ngState = ngp.getSessionState(req, res);

    if ( ngState.stale )                                                                            
      return;  

    var ecxSid = ngState.ecxSid;
    res.ecxSid = ecxSid;

    var stepsStream = JSON.parse(JSON.stringify(funcSteps));                                    

    stepsStream.forEach(function(step){
      step.ip = ngp.localIp;
      step.port = ngp.ecxExternal;

      step.func = pingURLFuncs[step.name];                                                  

      step.cb = function(ecxSid, data){ 
			//@#@ ngp.logMsg('info', "Finished step '" + ngState.currentFunc + '(' + this.name + ")' in session ID '" + ecxSid + "'");
			ngp.logMsg('info', "Finished step '" + ngp.getCurrentFunc(step.reqId, ecxSid) + '(' + this.name + ")' in session ID '" + ecxSid + "'");

        if ( data )
        {
          ngp.logMsg('debug', "Data returned by step '" + ngState.currentFunc + '(' + this.name + ")' in session ID '" + ecxSid + "'=" + JSON.stringify(data));
        }
      };
    });

    ngp.createRequestStore(stepsStream, ecxSid, req.reqId, 'pingURL');  

    ngState.currentFunc = 'pingURL';                                 
    return stepsStream;
}

function pingURL(step, funcStream, ecxSessionId, oFromNg, cb)
{
    const ping = require('ping');
    const urlParse = require('url-parse');
    var hostNameIP = urlParse(oFromNg.url).hostname;

    ping.sys.probe(hostNameIP, function(isAlive) {

      if(isAlive) {
        var result = {
           hostNameIP: hostNameIP,
           ping: true,
           statusCode: 200    
       };
               
     } 
     else {
       var result = {
         hostNameIP: hostNameIP,
         ping: false,
         statusCode: 200    
        };
     }
     ngp.setStepSuccessResult(step, funcStream, ecxSessionId, oFromNg, cb, result);
    });
}

